// demo1Dlg.cpp : implementation file

#include "stdafx.h"
#include "demo1.h"
#include "demo1Dlg.h"
#include "VCI_CAN.h"
#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
CString TmpMsg;
char SaveFile_Path[MAX_PATH];
char *endptr;
int Ret;
BYTE ComPort;
BYTE AutoRx_Flag=0;
DWORD Total_RxMsgCnt=0, CAN1_MsgCnt=0, CAN2_MsgCnt=0;
DWORD MyTest0_Val=0, MyTest1_Val=0;
_VCI_CAN_MSG CANTx, CANRx;

UINT AutoRxMsgThread(LPVOID lParam);


void CDemo1Dlg::Show_ErrCode(int ErrCode)
{
	CString TmpMsg1;

	TmpMsg1.Format("ErrCode= %d ; ErrMesg= \"%s\"", ErrCode, ErrMessage[ErrCode]);
	m_lblStatus1.Format(_T("%s"), TmpMsg1);
	UpdateData(FALSE);
}




// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo1Dlg dialog

CDemo1Dlg::CDemo1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo1Dlg)
	m_lblStatus1 = _T("");
	m_RecvNum = _T("");
	m_RecvNum2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo1Dlg)
	DDX_Control(pDX, IDC_CBO_RTR, m_RTR);
	DDX_Control(pDX, IDC_CBO_DLC, m_DLC);
	DDX_Control(pDX, IDC_CBO_MODULE, m_Module);
	DDX_Control(pDX, IDC_CBO_CAN2Baud, m_CAN2Baud);
	DDX_Control(pDX, IDC_CBO_CAN1Baud, m_CAN1Baud);
	DDX_Control(pDX, IDC_CBO_COMPORT, m_ComPort);
	DDX_Control(pDX, IDC_CBO_CANPORT, m_CANPort);
	DDX_Control(pDX, IDC_CHK_Auto_RxScan, m_Auto_RxScan);
	DDX_Control(pDX, IDC_Btn_CANRecv, m_CANRecv);
	DDX_Control(pDX, IDC_Btn_CANSend, m_CANSend);
	DDX_Control(pDX, IDC_Btn_OpenCAN, m_OpenCAN);
	DDX_Control(pDX, IDC_Btn_CloseCAN, m_CloseCAN);
	DDX_Control(pDX, IDC_LIST1, m_listbox);
	DDX_Control(pDX, IDC_EDIT11, m_txtTxdata7);
	DDX_Control(pDX, IDC_EDIT10, m_txtTxdata6);
	DDX_Control(pDX, IDC_EDIT9, m_txtTxdata5);
	DDX_Control(pDX, IDC_EDIT8, m_txtTxdata4);
	DDX_Control(pDX, IDC_EDIT7, m_txtTxdata3);
	DDX_Control(pDX, IDC_EDIT6, m_txtTxdata2);
	DDX_Control(pDX, IDC_EDIT5, m_txtTxdata1);
	DDX_Control(pDX, IDC_EDIT4, m_txtTxdata0);
	DDX_Control(pDX, IDC_EDIT1, m_txtTxid);
	DDX_Control(pDX, IDC_CHECK1, m_Check1);
	DDX_Text(pDX, IDC_STATIC_STATUS1, m_lblStatus1);
	DDX_Text(pDX, IDC_STATIC_RecvNum, m_RecvNum);
	DDX_Text(pDX, IDC_STATIC_RecvNum2, m_RecvNum2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDemo1Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON3, OnClearOverrun)
	ON_BN_CLICKED(IDC_Btn_OpenCAN, OnBtnOpenCAN)
	ON_BN_CLICKED(IDC_Btn_CloseCAN, OnBtnCloseCAN)
	ON_BN_CLICKED(IDC_Btn_CANSend, OnBtnCANSend)
	ON_BN_CLICKED(IDC_Btn_CANRecv, OnBtnCANRecv)
	ON_BN_CLICKED(IDC_CHK_Auto_RxScan, OnCHKAutoRxScan)
	ON_BN_CLICKED(IDC_SaveToFile, OnSaveToFile)
	ON_BN_CLICKED(IDC_BTN_SETUSERDEFISR, OnBtnSetuserdefisr)
	ON_BN_CLICKED(IDC_BTN_CLRUSERDEFISR, OnBtnClruserdefisr)
	ON_BN_CLICKED(IDC_BTN_ISRShowCnt, OnBTNISRShowCnt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo1Dlg message handlers

BOOL CDemo1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	// TODO: Add extra initialization here
	m_CloseCAN.EnableWindow(FALSE);
	m_CANSend.EnableWindow(FALSE);
	m_CANRecv.EnableWindow(FALSE);

	m_Module.SetCurSel(1);
	m_CAN1Baud.SetCurSel(11);
	m_CAN2Baud.SetCurSel(11);
	m_ComPort.SetCurSel(41);
	
	m_txtTxid.SetWindowText("123");
	m_RTR.SetCurSel(0);
	m_DLC.SetCurSel(8);
	m_txtTxdata0.SetWindowText("12");
	m_txtTxdata1.SetWindowText("34");
	m_txtTxdata2.SetWindowText("56");
	m_txtTxdata3.SetWindowText("78");
	m_txtTxdata4.SetWindowText("90");
	m_txtTxdata5.SetWindowText("AB");
	m_txtTxdata6.SetWindowText("CD");
	m_txtTxdata7.SetWindowText("EF");
	m_CANPort.SetCurSel(0);
	
	m_Auto_RxScan.SetCheck(1);
	m_RecvNum.Format(_T("%d"), 0);
	m_RecvNum2.Format(_T("%d"), 0);

	GetCurrentDirectory(MAX_PATH, SaveFile_Path);

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemo1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemo1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemo1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemo1Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	CDialog::OnCancel();
}

void CDemo1Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//Close ComPort	
	Ret = VCI_CloseCAN(ComPort);
}

void CDemo1Dlg::OnClearOverrun() // Clear Data Overrun
{
	if(m_listbox.GetCount()>0){
		m_listbox.ResetContent();
	}

	Total_RxMsgCnt = 0;
	CAN1_MsgCnt=0;
	CAN2_MsgCnt=0;
	m_RecvNum.Format(_T("%d"), CAN1_MsgCnt);
	m_RecvNum2.Format(_T("%d"), CAN2_MsgCnt);
	UpdateData(FALSE);

	Ret = VCI_Clr_RxMsgBuf(CAN1);
	Ret = VCI_Clr_RxMsgBuf(CAN2);
	if(Ret){
		Show_ErrCode(Ret);
	}
}

void CDemo1Dlg::OnBtnOpenCAN() 
{
	_VCI_CAN_PARAM pCANPARAM;
	BYTE Mod_CfgData[512];

	//Listen Only Mode
	Mod_CfgData[0] = 0;									//CAN1 => 0:Disable, 1:Enable
	Mod_CfgData[1] = 0;									//CAN2 => 0:Disable, 1:Enable
	VCI_Set_MOD_Ex(Mod_CfgData);
	
	//Open CAN
	ComPort = (BYTE)strtol(TmpMsg,&endptr,10);
	pCANPARAM.DevPort = m_ComPort.GetCurSel()+1;
	pCANPARAM.DevType = m_Module.GetCurSel()+1;			//Opt: I7565H1/I7565H2
	pCANPARAM.CAN1_Baud = CANBaud_Arr[m_CAN1Baud.GetCurSel()];		//Ex:  83.3K => 83300
	pCANPARAM.CAN2_Baud = CANBaud_Arr[m_CAN2Baud.GetCurSel()];
	Ret = VCI_OpenCAN(&pCANPARAM);
	if(Ret == No_Err){
		m_OpenCAN.EnableWindow(FALSE);
		m_CloseCAN.EnableWindow(TRUE);
		m_CANSend.EnableWindow(TRUE);
		m_CANRecv.EnableWindow(TRUE);
		m_Module.EnableWindow(FALSE);
		m_CAN1Baud.EnableWindow(FALSE);
		m_CAN2Baud.EnableWindow(FALSE);
		m_ComPort.EnableWindow(FALSE);

		if(m_Auto_RxScan.GetCheck()){
			OnCHKAutoRxScan();
		}
		m_lblStatus1.Format(_T("%s"), "OpenCAN Success");
		UpdateData(FALSE);
	}
	else{
		Show_ErrCode(Ret);
	}
}

void CDemo1Dlg::OnBtnCloseCAN() 
{
	if(AutoRx_Flag){
		AutoRx_Flag=0;
		Sleep(100);
	}
	
	Ret = VCI_CloseCAN(m_ComPort.GetCurSel()+1);
	if(Ret == No_Err){
		m_OpenCAN.EnableWindow(TRUE);
		m_CloseCAN.EnableWindow(FALSE);
		m_CANSend.EnableWindow(FALSE);
		m_CANRecv.EnableWindow(FALSE);
		m_Module.EnableWindow(TRUE);
		m_CAN1Baud.EnableWindow(TRUE);
		m_CAN2Baud.EnableWindow(TRUE);
		m_ComPort.EnableWindow(TRUE);

		m_lblStatus1.Format(_T("%s"), "CloseCAN Success");
		UpdateData(FALSE);
	}
	else{
		Show_ErrCode(Ret);
	}
	
}

void CDemo1Dlg::OnBtnCANSend() 
{
	char TempTxBuf[20];


	//[1] Mode
	if (m_Check1.GetCheck() == 1){
		CANTx.Mode = 1;
	}
	else{
		CANTx.Mode = 0;
	}
 
	//[2] ID
	if(CANTx.Mode == 0){
		m_txtTxid.GetWindowText(TempTxBuf,4);
		CANTx.ID = strtoul(TempTxBuf,&endptr,16);
		if (CANTx.ID > 0x7FF){
			m_lblStatus1.Format(_T("%s"), "ID  error !!");
			UpdateData(FALSE);
			return;
		}
	}
	else{
		m_txtTxid.GetWindowText(TempTxBuf,9);
		CANTx.ID = strtoul(TempTxBuf,&endptr,16);
		if (CANTx.ID > 0x1FFFFFFF){
			m_lblStatus1.Format(_T("%s"), "ID  error !!");
			UpdateData(FALSE);
			return;
		}
	}

	//[3] RTR
	CANTx.RTR = m_RTR.GetCurSel();
	if(CANTx.RTR>1){
		m_lblStatus1.Format(_T("%s"), "RTR  error !!");
		UpdateData(FALSE);
		return;
	}

	//[4] DLC
	CANTx.DLC = m_DLC.GetCurSel();
	if(CANTx.DLC>8){
		m_lblStatus1.Format(_T("%s"), "DLC  error !!");
		UpdateData(FALSE);
		return;
	}
  
	//[5] Data[0] ~ Data[7]
	m_txtTxdata0.GetWindowText(TempTxBuf,20);
	CANTx.Data[0] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata1.GetWindowText(TempTxBuf,20);
	CANTx.Data[1] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata2.GetWindowText(TempTxBuf,20);
	CANTx.Data[2] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata3.GetWindowText(TempTxBuf,20);
	CANTx.Data[3] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata4.GetWindowText(TempTxBuf,20);
	CANTx.Data[4] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata5.GetWindowText(TempTxBuf,20);
	CANTx.Data[5] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata6.GetWindowText(TempTxBuf,20);
	CANTx.Data[6] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_txtTxdata7.GetWindowText(TempTxBuf,20);
	CANTx.Data[7] = (BYTE)strtol(TempTxBuf,&endptr,16);
  
	//Send CANMsg
	Ret = VCI_SendCANMsg(m_CANPort.GetCurSel()+1, &CANTx);
	if(Ret){
		Show_ErrCode(Ret);
	}
	
}

void CDemo1Dlg::OnBtnCANRecv() 
{
	DWORD RxMsgCnt=0, j=0;
	char Temp[200];
	double ReceiveTimeStamp;
	BYTE ChIdx=0;

	
	for(ChIdx=1; ChIdx<3; ChIdx++)
	{
		//ˬdثe٦hֵCANMsg|
		VCI_Get_RxMsgCnt(ChIdx, &RxMsgCnt);
		if (RxMsgCnt>0){
			//Forj鱵CANMsg
			for(j=0; j<RxMsgCnt; j++){
				Ret = VCI_RecvCANMsg(ChIdx, &CANRx);
				if(Ret){
					Show_ErrCode(Ret);
					return;
				}
				ReceiveTimeStamp = ((double)(CANRx.TimeH*pow(2.0,32.0))+(double)((double)CANRx.TimeL/10000));
				memset(Temp, 0, sizeof(Temp));
				sprintf(Temp,"CAN%d : [ %0.4f ]  ==>  %d  %X  %d  %d", ChIdx, ReceiveTimeStamp, CANRx.Mode, CANRx.ID, CANRx.RTR, CANRx.DLC);
				if(CANRx.RTR==0){
					if(CANRx.DLC>0) sprintf(Temp,"%s  %02X", Temp, CANRx.Data[0]);
					if(CANRx.DLC>1) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[1]);
					if(CANRx.DLC>2) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[2]);
					if(CANRx.DLC>3) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[3]);
					if(CANRx.DLC>4) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[4]);
					if(CANRx.DLC>5) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[5]);
					if(CANRx.DLC>6) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[6]);
					if(CANRx.DLC>7) sprintf(Temp,"%s_%02X", Temp, CANRx.Data[7]);
				}
				m_listbox.AddString(Temp);
			}

			if(ChIdx==1){
				CAN1_MsgCnt = CAN1_MsgCnt + RxMsgCnt;
				m_RecvNum.Format(_T("%d"), CAN1_MsgCnt);
			}
			else{
				CAN2_MsgCnt = CAN2_MsgCnt + RxMsgCnt;
				m_RecvNum2.Format(_T("%d"), CAN2_MsgCnt);
			}

			//ܱCANMsgTotal
			Total_RxMsgCnt += RxMsgCnt;
			UpdateData(FALSE);

			//̷ܳs@CANMsg
			m_listbox.SetTopIndex(Total_RxMsgCnt-9);
		}
	}
	
}



UINT AutoRxMsgThread(LPVOID lParam)
{
	CDemo1Dlg* pDlg = (CDemo1Dlg*)lParam;
	DWORD SleepCnt=0;
	
	while(AutoRx_Flag){
		pDlg->OnBtnCANRecv();

		//Reduce CPU Loading
		if(((SleepCnt++) & 0x1F)==0){
			Sleep(1);
		}
	}

	return 0;
}

void CDemo1Dlg::OnCHKAutoRxScan() 
{
	if(m_Auto_RxScan.GetCheck()){
		AutoRx_Flag=1;
		m_CANRecv.EnableWindow(FALSE);
		AfxBeginThread(AutoRxMsgThread, this);
	}
	else{
		AutoRx_Flag=0;
		m_CANRecv.EnableWindow(TRUE);
	}
}

void CDemo1Dlg::OnSaveToFile() 
{
	int i;
	char tmp[100];
	char SaveFile[500], FileName[50]="CANMsg_File.txt";
	FILE *fp;

	sprintf(SaveFile, "%s\\%s", SaveFile_Path, FileName);
	fp = fopen(SaveFile, "w+t");

	for(i = 0; i < m_listbox.GetCount(); i++)
	{
		m_listbox.GetText(i,tmp);
		fprintf(fp, "%s\n", tmp);
	}

	fclose(fp);

	AfxMessageBox("File Save OK");
}

void MyTestISR0(void)
{
	MyTest0_Val++;
	//AfxMessageBox("MyTestISR-0 Run !!");
}

void MyTestISR1(void)
{
	MyTest1_Val++;
	//AfxMessageBox("MyTestISR-1 Run !!");
}

void CDemo1Dlg::OnBtnSetuserdefisr() 
{	
	MyTest0_Val = 0;
	MyTest1_Val = 0;

	/* Enable UserDefISR Function */
	//The UserDefISR (MyTestISR0) will be trigged when receiving any one CANMsg
	VCI_Set_UserDefISR(ISRNO_0, ISR_CANPORT_ALL, ISR_CANMODE_ALL, ISR_CANID_ALL, MyTestISR0);

	//The UserDefISR (MyTestISR1) will be trigged when only receiving CANMsg with CANID=0x100
	VCI_Set_UserDefISR(ISRNO_1, CAN1, MODE_11BIT, 0x100, MyTestISR1);
}

void CDemo1Dlg::OnBtnClruserdefisr() 
{
	/* Disable UserDefISR Function */
	VCI_Clr_UserDefISR(ISRNO_0);
	VCI_Clr_UserDefISR(ISRNO_1);
}

void CDemo1Dlg::OnBTNISRShowCnt() 
{
	TmpMsg.Format("ISR0_Val=%lu, ISR1_Val=%lu", MyTest0_Val, MyTest1_Val);
	AfxMessageBox(TmpMsg);	
}
